SystemOrganization addCategory: #ConfigurationOfPostMark!

Object subclass: #ConfigurationOfPostMark
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPostMark'!

!ConfigurationOfPostMark class methodsFor: 'development support' stamp: 'FrancoisStephany 12/15/2011 21:38'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPostMark class methodsFor: 'private' stamp: 'FrancoisStephany 12/15/2011 21:38'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPostMark class methodsFor: 'private' stamp: 'FrancoisStephany 12/15/2011 21:38'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPostMark class methodsFor: 'private' stamp: 'FrancoisStephany 12/15/2011 21:38'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPostMark class methodsFor: 'metacello tool support' stamp: 'FrancoisStephany 12/15/2011 21:38'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPostMark class methodsFor: 'loading' stamp: 'FrancoisStephany 12/15/2011 21:38'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPostMark class methodsFor: 'loading' stamp: 'FrancoisStephany 12/15/2011 21:38'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPostMark class methodsFor: 'loading' stamp: 'FrancoisStephany 12/15/2011 21:38'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPostMark class methodsFor: 'accessing' stamp: 'FrancoisStephany 12/15/2011 21:38'!
project

	^self new project! !

!ConfigurationOfPostMark class methodsFor: 'development support' stamp: 'FrancoisStephany 12/15/2011 21:38'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPostMark methodsFor: 'baselines' stamp: 'FrancoisStephany 12/19/2011 19:00'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec project: 'ZincHTTPComponents' with: [
				spec
					className: 'ConfigurationOfZincHTTPComponents';
					repository: 'http://www.squeaksource.com/ZincHTTPComponents' ].
		spec
			repository: 'http://www.squeaksource.com/JSON';
			package: 'JSON'.
		spec
			repository: 'http://ss3.gemstone.com/ss/postmark';
			package: 'PostMark-Core' with: [ 
				spec requires: #('ZincHTTPComponents' 'JSON') ];
			package: 'PostMark-Tests' with: [ 
				spec requires: #('PostMark-Core') ] ].
! !

!ConfigurationOfPostMark methodsFor: 'accessing' stamp: 'FrancoisStephany 12/15/2011 21:38'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPostMark methodsFor: 'symbolic versions' stamp: 'FrancoisStephany 12/15/2011 21:47'!
stable: spec
	<symbolicVersion: #'stable'>
	spec for: #'pharo1.3.x' version: '0.1'.
! !

!ConfigurationOfPostMark methodsFor: 'versions' stamp: 'FrancoisStephany 12/15/2011 21:46'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec for: #common do: [
		spec blessing: #release.
		spec
			package: 'JSON'                 with: 'JSON-ul.35';
			package: 'PostMark-Core'  with: 'PostMark-Core-FrancoisStephany.2';
			package: 'PostMark-Tests' with: 'PostMark-Tests-FrancoisStephany.2' ].! !

!ConfigurationOfPostMark methodsFor: 'versions' stamp: 'FrancoisStephany 12/20/2011 16:26'!
version02: spec
	<version: '0.2' imports: #('0.1-baseline')>
	spec for: #common do: [
		spec blessing: #release.
		spec
			package: 'JSON'                 with: 'JSON-ul.35';
			package: 'PostMark-Core'  with: 'PostMark-Core-FrancoisStephany.4';
			package: 'PostMark-Tests' with: 'PostMark-Tests-FrancoisStephany.2' ].! !
